'From Squeak2.8alpha of 4 February 2000 [latest update: #2098] on 13 May 2000 at 11:29:38 am'!
"Change Set:		BrowserWithDragAndDrop
Date:			6 May 2000
Author:			Stephan Rudlof
Release:			0.6.3

Drag&drop for morphic standard browsers!!

Usage:
	Just press the red button (after pressing shift key or not) and drag inside a browser window 
	or from one browser window to another (you *don't* need two windows!!!!):
		- a method in another message category,
		- a class in another class category,
		- a method from a class to another class.

There is
	- copy semantic, if shift key pressed,
	- move semantic, if shift key not pressed.

The user has to confirm, if some method should be overwritten.

DoIts:
	Browser openBrowser.

Preferences:
	There are 'browsing' preferences
		- 'browseWithDragNDrop', default is 'on';
		- 'dragNDropWithAnimation', default is 'on'.

Have fun!!!!

History:

0.6.3	Drag&drop for PackageBrowser;
		drag&drop works reasonably with Preferences>>smartUpdating off, now;
		Utilities>>dragNDropDomestosStrong for removal of worse drag&drop artifacts (called in postscript).
0.6.2	Improvement (probably): animation forked at Processor>>userBackgroundPriority instead of actual priority now.
0.6.1	Bugfix: if a message category has to be newly created (taken from source class), it will be automatically created now.
0.6		copy/move semantic controlled by shift key:
		-> copy visualized by cursor with '+',
		-> move visualized by cursor without '+' and animation,
			- successful move has another animation as unsuccessful one;
		refactored and improved Browser code;
		animation of #move operation (controlled by Preferences).
		
0.5		Drag&drop inside hierarchies: moving methods from sub/super to super/sub class
			-> works in HierarchyBrowsers!!!!
		Drag&drop between hierarchies: copying methods from class to class;
		TransferMorph: better visualization (from Henrik Gedenryd)
			-> the item will be dragged now;
		Implementation integrated in standard classes now.

0.4		Drag&drop inside browsers, better logic, better visualization.

0.3		Drag&drop triggered by pressing red mouse button and just moving mouse;
		PluggableListMorphWithDragAndDrop:
			event handling improved
			-> mouseUp deselects now (better for drag&drop).

0.2.1	PluggableListMorphWithDragAndDrop: superfluous inst var removed
0.2		Drag&drop triggered by pressing red mouse button longer than DoubleClickTime.

0.1		Drag&drop triggered by pressing shift-key and then red mouse button."!

ScrollPane subclass: #PluggableListMorph
	instanceVariableNames: 'list selectedMorph selection getListSelector getIndexSelector setIndexSelector keystrokeActionSelector autoDeselect font lastKeystrokeTime lastKeystrokes lastClickTime doubleClickSelector eventStatus dragEnabled dropEnabled lastMouseDownPosition potentialDropMorph '
	classVariableNames: 'DoubleClickTime '
	poolDictionaries: ''
	category: 'Morphic-Windows'!
PolygonMorph subclass: #PolygonMorphDashed
	instanceVariableNames: 'secondBorderWidth secondBorderColor firstBorderStepWidth secondBorderStepWidth '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-D&D'!

!PolygonMorphDashed commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

| m |
m _ (PolygonMorphDashed
			vertices: (Array with: 0@0 with: 200@200)
			color: (Color transparent)
			firstBorderWidth: 1
			secondBorderWidth: 1
			firstBorderColor: Color black
			secondBorderColor: Color white
			firstBorderStepWidth: 10
			secondBorderStepWidth: 3).
m addHandles.
m openInWorld.


Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!
Morph subclass: #TransferMorph
	instanceVariableNames: 'passenger source dropNotifyRecipient accepted resultRecipient myPolygon startPoint stopPoint semantic startPosition startPositionForLine successFlag dragActionActive '
	classVariableNames: 'PlusForCursor '
	poolDictionaries: ''
	category: 'Morphic-Support'!

!TransferMorph commentStamp: '<historical>' prior: 0!
A TransferMorph is a vehicle to transfers something from a source to some target by a drag&drop operation. Its lifetime is short. It has methods to notify some object, if it was accepted by another morph and to send some object a possible result of the drop operation. It deletes itself after dropping. Acceptance means, that an arbitrary morph *except* theWorld wanted it by >>wantsDroppedMorph:event:.

TransferMorph new openInWorld.

If you move it somewhere it diminishes ;-)

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

!Browser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 03:23'!
openAsMorphClassEditing: editString 
	"Create a pluggable version a Browser on just a single class."
	| window switches codePane baseline aTextMorph dragNDropFlag |
	window _ (SystemWindow labelled: 'later')
				model: self.
	dragNDropFlag _ Preferences browseWithDragNDrop.
	window addMorph: (PluggableListMorph
			on: self
			list: #classListSingleton
			selected: #indexIsOne
			changeSelected: #indexIsOne:
			menu: #classListMenu:
			keystroke: #classListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0 @ 0 extent: 0.5 @ 0.06).
	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0.5 @ 0 extent: 0.5 @ 0.06).
	switches borderWidth: 0.
	window addMorph: (PluggableMessageCategoryListMorph
			on: self
			list: #messageCategoryList
			selected: #messageCategoryListIndex
			changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:
			keystroke: #arrowKey:from:
			getRawListSelector: #rawMessageCategoryList
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0 @ 0.06 extent: 0.5 @ 0.3).
	window addMorph: (PluggableListMorph
			on: self
			list: #messageList
			selected: #messageListIndex
			changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0.5 @ 0.06 extent: 0.5 @ 0.3).
	Preferences useAnnotationPanes
		ifTrue: 
			[aTextMorph _ PluggableTextMorph
						on: self
						text: #annotation
						accept: nil
						readSelection: nil
						menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph frame: (0 @ 0.36 corner: 1 @ 0.41).
			baseline _ 0.41]
		ifFalse: [baseline _ 0.36].
	Preferences optionalButtons
		ifTrue: 
			[window addMorph: self optionalButtonRow frame: (0 @ baseline corner: 1 @ (baseline + 0.08)).
			baseline _ baseline + 0.08].
	codePane _ PluggableTextMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	editString
		ifNotNil: 
			[codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	window addMorph: codePane frame: (0 @ baseline corner: 1 @ 1).
	window setUpdatablePanesFrom: #(messageCategoryList messageList ).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 03:23'!
openAsMorphEditing: editString 
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window switches codePane aListMorph baseline aTextMorph dragNDropFlag |
	window _ (SystemWindow labelled: 'later')
				model: self.
	dragNDropFlag _ Preferences browseWithDragNDrop.
	window addMorph: (PluggableListMorph
			on: self
			list: #systemCategoryList
			selected: #systemCategoryListIndex
			changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu:
			keystroke: #systemCatListKey:from:
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0 @ 0 extent: 0.25 @ 0.4).
	window addMorph: (PluggableListMorph
			on: self
			list: #classList
			selected: #classListIndex
			changeSelected: #classListIndex:
			menu: #classListMenu:
			keystroke: #classListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0.25 @ 0 extent: 0.25 @ 0.3).
	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0.25 @ 0.3 extent: 0.25 @ 0.1).
	switches borderWidth: 0.
	window addMorph: (PluggableMessageCategoryListMorph
			on: self
			list: #messageCategoryList
			selected: #messageCategoryListIndex
			changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:
			keystroke: #arrowKey:from:
			getRawListSelector: #rawMessageCategoryList
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0.5 @ 0 extent: 0.25 @ 0.4).
	aListMorph _ PluggableListMorph
				on: self
				list: #messageList
				selected: #messageListIndex
				changeSelected: #messageListIndex:
				menu: #messageListMenu:shifted:
				keystroke: #messageListKey:from:
				dragAndDropEnabled: dragNDropFlag.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph frame: (0.75 @ 0 extent: 0.25 @ 0.4).
	Preferences useAnnotationPanes
		ifTrue: 
			[aTextMorph _ PluggableTextMorph
						on: self
						text: #annotation
						accept: nil
						readSelection: nil
						menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph frame: (0 @ 0.4 corner: 1 @ 0.45).
			baseline _ 0.45]
		ifFalse: [baseline _ 0.4].
	Preferences optionalButtons
		ifTrue: 
			[window addMorph: self optionalButtonRow frame: (0 @ baseline corner: 1 @ (baseline + 0.08)).
			baseline _ baseline + 0.08].
	codePane _ PluggableTextMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	editString
		ifNotNil: 
			[codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	window addMorph: codePane frame: (0 @ baseline corner: 1 @ 1).
	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList ).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 03:23'!
openAsMorphMessageEditing: editString
	"Create a pluggable version a Browser that shows just one message"
	| window codePane baseline aTextMorph |
	window _ (SystemWindow labelled: 'later') model: self.

	window addMorph: (PluggableListMorph on: self list: #messageListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:
			dragAndDropEnabled: Preferences browseWithDragNDrop)
		frame: (0@0 extent: 1.0@0.06).

	Preferences useAnnotationPanes
		ifFalse:
			[baseline _ 0.06]
		ifTrue:
			[aTextMorph _ PluggableTextMorph on: self
					text: #annotation accept: nil
					readSelection: nil menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph
				frame: (0@0.06 corner: 1@0.11).
			baseline _ 0.11].

	Preferences optionalButtons
		ifTrue:
			[window addMorph: self optionalButtonRow frame: ((0@baseline corner: 1 @ (baseline + 0.08))).
			baseline _ baseline + 0.08].

	codePane _ PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	editString ifNotNil: [codePane editString: editString.
					codePane hasUnacceptedEdits: true].
	window addMorph: codePane
		frame: (0@baseline corner: 1@1).

	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 03:24'!
openAsMorphMsgCatEditing: editString
	"Create a pluggable version a Browser on just a messageCategory."
	| window codePane baseline aTextMorph |
	window _ (SystemWindow labelled: 'later') model: self.

	window addMorph: (PluggableListMorph on: self list: #messageCatListSingleton
			selected: #indexIsOne changeSelected: #indexIsOne:
			menu: #messageCategoryMenu: dragAndDropEnabled: Preferences browseWithDragNDrop)
		frame: (0@0 extent: 1.0@0.06).
	window addMorph: (PluggableListMorph on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from: dragAndDropEnabled: Preferences browseWithDragNDrop)
		frame: (0@0.06 extent: 1.0@0.30).

	Preferences useAnnotationPanes
		ifFalse:
			[baseline _ 0.30]
		ifTrue:
			[aTextMorph _ PluggableTextMorph on: self
					text: #annotation accept: nil
					readSelection: nil menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph
				frame: (0@0.30 corner: 1@0.35).
			baseline _ 0.35].

	Preferences optionalButtons
		ifTrue:
			[window addMorph: self optionalButtonRow frame: ((0@baseline corner: 1 @ (baseline + 0.08))).
			baseline _ baseline + 0.08].

	codePane _ PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	editString ifNotNil: [codePane editString: editString.
					codePane hasUnacceptedEdits: true].
	window addMorph: codePane
		frame: (0@baseline corner: 1@1).

	window setUpdatablePanesFrom: #(messageCatListSingleton messageList).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 03:25'!
openAsMorphSysCatEditing: editString 
	"Create a pluggable version of all the views for a Browser, including 
	views and controllers."
	| window switches codePane baseline aTextMorph dragNDropFlag |
	window _ (SystemWindow labelled: 'later')
				model: self.
	dragNDropFlag _ Preferences browseWithDragNDrop.
	window addMorph: (PluggableListMorph
			on: self
			list: #systemCategorySingleton
			selected: #indexIsOne
			changeSelected: #indexIsOne:
			menu: #systemCatSingletonMenu:
			keystroke: #systemCatSingletonKey:from:
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0 @ 0 extent: 1.0 @ 0.06).
	window addMorph: (PluggableListMorph
			on: self
			list: #classList
			selected: #classListIndex
			changeSelected: #classListIndex:
			menu: #classListMenu:
			keystroke: #classListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0 @ 0.06 extent: 0.3333 @ 0.24).
	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0 @ 0.3 extent: 0.3333 @ 0.06).
	switches borderWidth: 0.
	window addMorph: (PluggableMessageCategoryListMorph
			on: self
			list: #messageCategoryList
			selected: #messageCategoryListIndex
			changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:
			keystroke: #arrowKey:from:
			getRawListSelector: #rawMessageCategoryList
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0.3333 @ 0.06 extent: 0.3333 @ 0.3).
	window addMorph: (PluggableListMorph
			on: self
			list: #messageList
			selected: #messageListIndex
			changeSelected: #messageListIndex:
			menu: #messageListMenu:shifted:
			keystroke: #messageListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0.6666 @ 0.06 extent: 0.3333 @ 0.3).
	Preferences useAnnotationPanes
		ifTrue: 
			[baseline _ 0.41.
			aTextMorph _ PluggableTextMorph
						on: self
						text: #annotation
						accept: nil
						readSelection: nil
						menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph frame: (0 @ 0.36 corner: 1 @ baseline)]
		ifFalse: [baseline _ 0.36].
	Preferences optionalButtons
		ifTrue: 
			[window addMorph: self optionalButtonRow frame: (0 @ baseline corner: 1 @ (baseline + 0.08)).
			baseline _ baseline + 0.08].
	codePane _ PluggableTextMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	editString
		ifNotNil: 
			[codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	window addMorph: codePane frame: (0 @ baseline corner: 1 @ 1).
	window setUpdatablePanesFrom: #(classList messageCategoryList messageList ).
	^ window! !

!Browser methodsFor: 'message category list' stamp: 'sr 5/5/2000 23:36'!
selectedMessageCategoryName
	"Answer the name of the selected message category, if any. Answer nil   
	   otherwise."
	messageCategoryListIndex > self messageCategoryList size ifTrue: [messageCategoryListIndex _ 0].
	messageCategoryListIndex = 0 ifTrue: [^ nil].
	^ self messageCategoryList at: messageCategoryListIndex! !

!Browser methodsFor: 'message list' stamp: 'sr 4/27/2000 21:55'!
selectedMessage
	"Answer a copy of the source code for the selected message selector."
	| class selector method tempNames |
	contents == nil ifFalse: [^ contents copy].
	class _ self selectedClassOrMetaClass.
	selector _ self selectedMessageName.
	method _ class ifNotNil: [class compiledMethodAt: selector ifAbsent: [^ '']].
	"method deleted while in another project"
	currentCompiledMethod _ method.
	(Sensor controlKeyPressed
		or: [method fileIndex > 0 and: [(SourceFiles at: method fileIndex)
					== nil]])
		ifTrue: 
			["Emergency or no source file -- decompile without temp names"
			contents _ (class decompilerClass new
						decompile: selector
						in: class
						method: method) decompileString.
			contents _ contents asText makeSelectorBoldIn: class.
			^ contents copy].
	Sensor leftShiftDown
		ifTrue: 
			["Special request to decompile -- get temps from source file"
			tempNames _ (class compilerClass new
						parse: method getSourceFromFile asString
						in: class
						notifying: nil) tempNames.
			contents _ ((class decompilerClass new withTempNames: tempNames)
						decompile: selector
						in: class
						method: method) decompileString.
			contents _ contents asText makeSelectorBoldIn: class.
			^ contents copy].
	contents _ class sourceCodeAt: selector.
	self validateMessageSource: selector.
	Preferences browseWithPrettyPrint ifTrue: [contents _ class compilerClass new
					format: contents
					in: class
					notifying: nil
					decorated: Preferences colorWhenPrettyPrinting].
	self showDiffs ifTrue: [contents _ self diffFromPriorSourceFor: contents].
	contents _ contents asText makeSelectorBoldIn: class.
	^ contents copy! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/23/2000 09:58'!
classCategoryListMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableListMorph)
				and: [dep getListSelector == #systemCategoryList]]
		ifNone: []! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/23/2000 09:57'!
classListMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableListMorph)
				and: [dep getListSelector == #classList]]
		ifNone: []! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/25/2000 07:12'!
codeTextMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableTextMorph)
				and: [dep getTextSelector == #contents]]
		ifNone: []! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/25/2000 10:56'!
dstCategoryDstListMorph: dstListMorph internal: internal 
	| dropMorph |
	^ internal & (dstListMorph getListSelector == #systemCategoryList)
		ifTrue: [(dropMorph _ dstListMorph potentialDropMorph) ifNotNil: [dropMorph contents]]
		ifFalse: [self selectedSystemCategoryName]! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/25/2000 05:15'!
dstClassDstListMorph: dstListMorph internal: internal 
	| dropMorph |
	^ internal & (dstListMorph getListSelector == #classList)
		ifTrue: [(dropMorph _ dstListMorph potentialDropMorph) ifNotNil: [Smalltalk at: dropMorph contents withBlanksCondensed asSymbol]]
		ifFalse: [self selectedClass]! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/25/2000 04:45'!
dstMessageCategoryDstListMorph: dstListMorph internal: internal 
	| dropMorph |
	^ internal & (dstListMorph getListSelector == #messageCategoryList)
		ifTrue: 
			[dropMorph _ dstListMorph potentialDropMorph.
			dropMorph ifNotNil: [dropMorph contents asSymbol]]
		ifFalse: [self selectedMessageCategoryName]! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 5/5/2000 20:08'!
messageCategoryListMorph
	^ self dependents
		detect: [:dep | (dep isKindOf: PluggableListMorph)
				and: [dep getListSelector == #messageCategoryList]]
		ifNone: []! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 4/25/2000 13:05'!
overwriteDialogHierarchyChange: hierarchyChange higher: higherFlag sourceClassName: srcClassName destinationClassName: dstClassName methodSelector: methodSelector 
	| lf success |
	lf _ Character cr asString.
	success _ SelectionMenu
				confirm: 'There is a conflict.' , ' Overwrite' , (hierarchyChange
							ifTrue: [higherFlag
									ifTrue: [' superclass']
									ifFalse: [' subclass']]
							ifFalse: ['']) , ' method' , lf , dstClassName , '>>' , methodSelector , lf , 'by ' , (hierarchyChange
							ifTrue: ['moving']
							ifFalse: ['copying']) , ' method' , lf , srcClassName name , '>>' , methodSelector , ' ?'
				trueChoice: 'Yes, don''t care.'
				falseChoice: 'No, I have changed my opinion.'.
	^ success! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 5/5/2000 21:50'!
showDropSuccess: success list: aListMorph item: itemSelOrString 
	aListMorph ifNotNil: [aListMorph showDropSuccess: success forItemWithContents: (itemSelOrString ifNil: ['']) asSymbol]! !

!Browser methodsFor: 'dragNDrop util' stamp: 'sr 5/5/2000 23:28'!
updateAll
	(self dependents select: [:dep | dep isKindOf: SystemWindow])
		do: [:win | self updateListsAndCodeIn: win]! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 5/5/2000 23:43'!
acceptDroppingMorph: transferMorph event: evt atListMorph: dstListMorph 
	"Here we are fetching informations from the dropped transferMorph and 
	                 performing the correct action for this drop."
	| internal srcLS srcBrowser copyFlag success |
	Cursor wait
		showWhile: 
			[transferMorph dragActionActive: true.
			copyFlag _ transferMorph hasCopySemantic.
			srcBrowser _ transferMorph source model.
			internal _ self == srcBrowser.
			(internal not and: [Preferences smartUpdating not])
				ifTrue: [srcBrowser updateAll].
			srcLS _ transferMorph source getListSelector.
			success _ srcLS == #messageList
						ifTrue: [self
								acceptMethod: srcBrowser selectedMessageName
								messageCategory: srcBrowser selectedMessageCategoryName
								class: srcBrowser selectedClassOrMetaClass
								atListMorph: dstListMorph
								internal: internal
								copy: copyFlag]
						ifFalse: [srcLS == #classList
								ifTrue: [self
										changeCategoryForClass: srcBrowser selectedClass
										srcSystemCategory: srcBrowser selectedSystemCategoryName
										atListMorph: dstListMorph
										internal: internal
										copy: copyFlag]
								ifFalse: [self error: 'implementation']].
			transferMorph success: success.
			transferMorph dragActionActive: false].
	"sometimes cursor diminishes before (why?), so..."
	Cursor normal show! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 4/27/2000 23:54'!
acceptMethod: methodSel dstMessageCategory: dstMessageCategorySel srcMessageCategory: srcMessageCategorySel dstClass: dstClass dstClassOrMeta: dstClassOrMeta srcClassOrMeta: srcClassOrMeta internal: internal copySemantic: copyFlag 
	| success hierarchyChange higher checkForOverwrite |
	(success _ dstClassOrMeta ~~ nil) ifFalse: [^false].
	checkForOverwrite _ dstClassOrMeta selectors includes: methodSel.
	hierarchyChange _ (higher _ srcClassOrMeta inheritsFrom: dstClassOrMeta) | (dstClassOrMeta inheritsFrom: srcClassOrMeta).
	success _ (checkForOverwrite not
				or: [self
						overwriteDialogHierarchyChange: hierarchyChange
						higher: higher
						sourceClassName: srcClassOrMeta name
						destinationClassName: dstClassOrMeta name
						methodSelector: methodSel])
				and: [self
						message: methodSel
						compileInClass: dstClassOrMeta
						fromClass: srcClassOrMeta
						dstMessageCategory: dstMessageCategorySel
						srcMessageCategory: srcMessageCategorySel
						internal: internal
						copySemantic: copyFlag].
	self
		showDropSuccess: success
		list: self classListMorph
		item: dstClass name.
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 4/27/2000 22:36'!
acceptMethod: methodSel messageCategory: srcMessageCategorySel class: srcClassOrMeta atListMorph: dstListMorph internal: internal copy: copyFlag 
	| success dstClassOrMeta dstClass dstMessageCategorySel |
	dstClass _ self dstClassDstListMorph: dstListMorph internal: internal.
	dstClassOrMeta _ dstClass
				ifNotNil: [self metaClassIndicated
						ifTrue: [dstClass class]
						ifFalse: [dstClass]].
	dstMessageCategorySel _ self dstMessageCategoryDstListMorph: dstListMorph internal: internal.
	success _ (dstClassOrMeta notNil
				and: [dstClassOrMeta == srcClassOrMeta])
						ifTrue: ["one class"
							self
								changeMessageCategoryForMethod: methodSel
								dstMessageCategory: dstMessageCategorySel
								srcMessageCategory: srcMessageCategorySel
								insideClassOrMeta: dstClassOrMeta
								internal: internal
								copySemantic: copyFlag]
						ifFalse: ["different classes"
							self
								acceptMethod: methodSel
								dstMessageCategory: dstMessageCategorySel
								srcMessageCategory: srcMessageCategorySel
								dstClass: dstClass
								dstClassOrMeta: dstClassOrMeta
								srcClassOrMeta: srcClassOrMeta
								internal: internal
								copySemantic: copyFlag].
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 5/5/2000 18:40'!
changeCategoryForClass: class srcSystemCategory: srcSystemCategorySel atListMorph: dstListMorph internal: internal copy: copyFlag 
	"only move semantic"
	| newClassCategory success |
	self flag: #stringSymbolProblem.
	success _ copyFlag not ifFalse: [^ false].
	newClassCategory _ self dstCategoryDstListMorph: dstListMorph internal: internal.
	(success _ newClassCategory notNil & (newClassCategory ~= class category))
		ifTrue: 
			[class category: newClassCategory.
			self changed: #classList.
			internal ifFalse: [self selectClass: class]].
	self
		showDropSuccess: success
		list: self classCategoryListMorph
		item: newClassCategory.
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 5/5/2000 20:13'!
changeMessageCategoryForMethod: methodSel dstMessageCategory: dstMessageCategorySel srcMessageCategory: srcMessageCategorySel insideClassOrMeta: classOrMeta internal: internal copySemantic: copyFlag 
	"only move semantic"
	| success messageCategorySel |
	(success _ copyFlag not) ifFalse: [^ false].
	messageCategorySel _ dstMessageCategorySel ifNil: [srcMessageCategorySel].
	(success _ messageCategorySel notNil & (messageCategorySel ~= '-- all --' asSymbol)
				and: [messageCategorySel ~= srcMessageCategorySel and: [classOrMeta organization categories includes: messageCategorySel]])
		ifTrue: 
			[classOrMeta organization
				classify: methodSel
				under: messageCategorySel
				suppressIfDefault: false.
			self changed: #messageList].
	success & internal not ifTrue: [self setSelector: methodSel].
	self
		showDropSuccess: success
		list: self messageCategoryListMorph
		item: dstMessageCategorySel.
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 4/27/2000 20:27'!
changeMessageCategoryForMethod: methodSel dstMessageCategory: dstMessageCategorySel srcMessageCategory: srcMessageCategorySel insideClassOrMeta: classOrMeta internal: internal copySemantik: copyFlag 
	"only move semantic"
	| success messageCategorySel |
	(success _ copyFlag not) ifFalse: [^ false].
	messageCategorySel _ dstMessageCategorySel ifNil: [srcMessageCategorySel].
	(success _ messageCategorySel notNil & (messageCategorySel ~= '-- all --' asSymbol)
				and: [messageCategorySel ~= srcMessageCategorySel and: [classOrMeta organization categories includes: messageCategorySel]])
		ifTrue: [classOrMeta organization
				classify: methodSel
				under: messageCategorySel
				suppressIfDefault: false].
	success & internal not ifTrue: [self setSelector: methodSel].
	self
		showDropSuccess: success
		list: self messageCategoryListMorph
		item: dstMessageCategorySel.
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 5/6/2000 03:07'!
message: messageSel compileInClass: dstClassOrMeta fromClass: srcClassOrMeta dstMessageCategory: dstMessageCategorySel srcMessageCategory: srcMessageCategorySel internal: internal copySemantic: copyFlag 
	| source messageCategorySel tm success oldOrNoMethod newMethod |
	source _ srcClassOrMeta sourceCodeAt: messageSel.
	messageCategorySel _ dstMessageCategorySel ifNil: [srcMessageCategorySel].
	self selectClass: dstClassOrMeta.
	(self messageCategoryList includes: messageCategorySel)
		ifFalse: ["create message category"
			self classOrMetaClassOrganizer addCategory: messageCategorySel].
	self selectMessageCategoryNamed: messageCategorySel.
	tm _ self codeTextMorph.
	tm setText: source.
	tm setSelection: (0 to: 0).
	tm hasUnacceptedEdits: true.
	oldOrNoMethod _ srcClassOrMeta compiledMethodAt: messageSel ifAbsent: [].
	tm accept.
	"compilation successful?"
	newMethod _ dstClassOrMeta compiledMethodAt: messageSel ifAbsent: [].
	success _ newMethod ~~ nil & (newMethod ~~ oldOrNoMethod).
	"	success ifFalse: [TransferMorph allInstances do: [:e | e delete]].            
	 "
	success
		ifTrue: 
			[copyFlag not ifTrue: ["remove old method in move semantic if new exists"
		srcClassOrMeta removeSelector: messageSel].internal
				ifTrue: [self selectClass: srcClassOrMeta]
				ifFalse: [self selectClass: dstClassOrMeta].
			self setSelector: messageSel].
	^ success! !

!Browser methodsFor: 'dragNDrop' stamp: 'sr 4/23/2000 08:45'!
wantsDroppedMorph: transferMorph event: anEvent atListMorph: destinationLM 
	"We are only interested in TransferMorphs as wrappers for             
	informations. If their content is really interesting for us, will             
	determined later in >>acceptDroppingMorph:event:."
	| sourceLM internal srcLS dstLS srcModel |
	((transferMorph isKindOf: TransferMorph)
		and: [(sourceLM _ transferMorph source) notNil])
		ifFalse: [^ false].
	srcModel _ sourceLM model.
	(srcModel isKindOf: Browser) ifFalse: [^ false].
	internal _ self == srcModel.
	srcLS _ sourceLM getListSelector.
	dstLS _ destinationLM getListSelector.
	internal
		ifTrue: 
			[sourceLM ~~ destinationLM ifFalse: [^ false].
			srcLS == #messageList ifTrue: [^ dstLS == #messageCategoryList | (dstLS == #classList)].
			srcLS == #classList ifTrue: [^ dstLS == #systemCategoryList]]
		ifFalse: 
			["from other browser"
			srcLS == #messageList ifTrue: [^ dstLS == #messageList | (dstLS == #messageCategoryList) | (dstLS == #classList)].
			srcLS == #classList ifTrue: [^ dstLS == #classList | (dstLS == #systemCategoryList)]].
	^ false! !


!Canvas methodsFor: 'drawing' stamp: 'sr 4/27/2000 03:31'!
line: pt1 to: pt2 width: w1 color: c1 stepWidth: s1 secondWidth: w2 secondColor: c2 secondStepWidth: s2 
	"Draw a line using the given width, colors and steps; both steps can  
	have different stepWidths (firstStep, secondStep), draw widths and  
	colors."
	| bigSteps offsetPoint dist p1p2Vec deltaBig delta1 delta2 lastPoint bigStep |
	s1 = 0 & (s2 = 0) ifTrue: [^ self].
	dist _ pt1 dist: pt2.
	dist = 0 ifTrue: [^ self].
	bigStep _ s1 + s2.
	bigSteps _ dist / bigStep.
	p1p2Vec _ pt2 - pt1.
	deltaBig _ p1p2Vec / bigSteps.
	delta1 _ deltaBig * (s1 / bigStep).
	delta2 _ deltaBig * (s2 / bigStep).
	dist <= s1
		ifTrue: 
			[self
				line: pt1 rounded
				to: pt2 rounded
				width: w1
				color: c1.
			^ self].
	0 to: bigSteps truncated - 1 do: 
		[:bigStepIx | 
		self
			line: (pt1 + (offsetPoint _ deltaBig * bigStepIx)) rounded
			to: (pt1 + (offsetPoint _ offsetPoint + delta1)) rounded
			width: w1
			color: c1.
		self
			line: (pt1 + offsetPoint) rounded
			to: (pt1 + (offsetPoint + delta2)) rounded
			width: w2
			color: c2].
	"if there was no loop, offsetPoint is nil"
	lastPoint _ pt1 + ((offsetPoint ifNil: [0 @ 0])
					+ delta2).
	(lastPoint dist: pt2)
		<= s1
		ifTrue: [self
				line: lastPoint rounded
				to: pt2 rounded
				width: w1
				color: c1]
		ifFalse: 
			[self
				line: lastPoint rounded
				to: (lastPoint + delta1) rounded
				width: w1
				color: c1.
			self
				line: (lastPoint + delta1) rounded
				to: pt2
				width: w1
				color: c2]! !


!PackageBrowser methodsFor: 'initialize-release' stamp: 'sr 5/5/2000 22:13'!
openAsMorphEditing: editString 
	"Create a pluggable version of all the views for a Browser, including    
	views and controllers."
	"PackageBrowser openBrowser"
	| listHeight buttonHeight window switches codePane aListMorph dragNDropFlag |
	listHeight _ 0.33.
	buttonHeight _ 0.09.
	window _ (SystemWindow labelled: 'later')
				model: self.
	dragNDropFlag _ Preferences browseWithDragNDrop.
	window addMorph: (PluggableListMorph
			on: self
			list: #packageList
			selected: #packageListIndex
			changeSelected: #packageListIndex:
			menu: #packageMenu:
			keystroke: #packageListKey:from:)
		frame: (0 @ 0 extent: 0.15 @ listHeight).
	window addMorph: (PluggableListMorph
			on: self
			list: #systemCategoryList
			selected: #systemCategoryListIndex
			changeSelected: #systemCategoryListIndex:
			menu: #systemCategoryMenu:
			keystroke: #systemCatListKey:from:
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0.15 @ 0 extent: 0.2 @ listHeight).
	window addMorph: (PluggableListMorph
			on: self
			list: #classList
			selected: #classListIndex
			changeSelected: #classListIndex:
			menu: #classListMenu:
			keystroke: #classListKey:from:
			dragAndDropEnabled: dragNDropFlag)
		frame: (0.35 @ 0 extent: 0.25 @ (listHeight - buttonHeight)).
	switches _ self buildMorphicSwitches.
	window addMorph: switches frame: (0.35 @ (listHeight - buttonHeight) extent: 0.25 @ buttonHeight).
	switches borderWidth: 0.
	window addMorph: (PluggableListMorph
			on: self
			list: #messageCategoryList
			selected: #messageCategoryListIndex
			changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:
			dragEnabled: false
			dropEnabled: dragNDropFlag)
		frame: (0.6 @ 0 extent: 0.15 @ listHeight).
	aListMorph _ PluggableListMorph
				on: self
				list: #messageList
				selected: #messageListIndex
				changeSelected: #messageListIndex:
				menu: #messageListMenu:shifted:
				keystroke: #messageListKey:from:
				dragAndDropEnabled: dragNDropFlag.
	aListMorph menuTitleSelector: #messageListSelectorTitle.
	window addMorph: aListMorph frame: (0.75 @ 0 extent: 0.25 @ listHeight).
	codePane _ PluggableTextMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	editString
		ifNotNil: 
			[codePane editString: editString.
			codePane hasUnacceptedEdits: true].
	window addMorph: codePane frame: (0 @ listHeight corner: 1 @ 1).
	window setUpdatablePanesFrom: #(packageList systemCategoryList classList messageCategoryList messageList ).
	^ window! !

!PackageBrowser methodsFor: 'dragNDrop' stamp: 'sr 5/5/2000 18:41'!
changeCategoryForClass: class srcSystemCategory: srcSystemCategorySel atListMorph: dstListMorph internal: internal copy: copyFlag 
	"only move semantic"
	| newClassCategory success |
	self flag: #stringSymbolProblem.
	success _ copyFlag not ifFalse: [^ false].
	newClassCategory _ self dstCategoryDstListMorph: dstListMorph internal: internal.
	(success _ newClassCategory notNil & (newClassCategory ~= class category))
		ifTrue: 
			[class category: newClassCategory.
			self changed: #classList.
			internal ifFalse: [self selectClass: class]].
	self
		showDropSuccess: success
		list: self classCategoryListMorph
		item: (newClassCategory copyFrom: (newClassCategory indexOf: $- ifAbsent: [0])
					+ 1 to: newClassCategory size).
	^ success! !

!PackageBrowser methodsFor: 'dragNDrop util' stamp: 'sr 5/5/2000 17:52'!
dstCategoryDstListMorph: dstListMorph internal: internal 
	| dropMorph |
	^ internal & (dstListMorph getListSelector == #systemCategoryList)
		ifTrue: [(dropMorph _ dstListMorph potentialDropMorph) ifNotNil: [(self package , '-' , dropMorph contents) asSymbol]]
		ifFalse: [self selectedSystemCategoryName]! !


!PluggableButtonMorph methodsFor: 'accessing' stamp: 'sr 5/6/2000 07:12'!
model
	^model! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'sr 4/23/2000 05:34'!
dragAndDropEnabled: aBool
	self dragEnabled: aBool.
	self dropEnabled: aBool! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'sr 4/23/2000 05:32'!
initialize
	super initialize.
	dragEnabled _ false.
	dropEnabled _ false! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'sr 4/23/2000 05:36'!
list: listOfStrings 
	| morphList h loc index handler |
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty
		ifTrue: 
			[self setScrollDeltas.
			^ self selectedMorph: nil].
	"NOTE: we will want a quick StringMorph init message, possibly even     
	            combined with event install and positioning"
	font ifNil: [font _ Preferences standardListFont].
	morphList _ list
				collect: [:item | item isText
						ifTrue: [StringMorph
								contents: item
								font: font
								emphasis: (item emphasisAt: 1)]
						ifFalse: [StringMorph contents: item font: font]].
	"Set one event handler for all StringMorphs items."
	handler _ EventHandler new.
	handler
		on: #mouseDown
		send: #mouseDown:onItem:
		to: self.
	handler
		on: #mouseUp
		send: #mouseUp:onItem:
		to: self.
	self dragEnabled
		ifTrue: [handler
				on: #mouseStillDown
				send: #mouseStillDown:onItem:
				to: self].
	self dropEnabled
		ifTrue: 
			[handler
				on: #mouseEnterDragging
				send: #mouseEnterDragging:onItem:
				to: self.
			handler
				on: #mouseLeaveDragging
				send: #mouseLeaveDragging:onItem:
				to: self].
	morphList do: [:m | m eventHandler: handler].
	"Lay items out vertically and install them in the scroller"
	h _ morphList first height.
	"self listItemHeight"
	loc _ 0 @ 0.
	morphList do: 
		[:m | 
		m bounds: (loc extent: 9999 @ h).
		loc _ loc + (0 @ h)].
	scroller addAllMorphs: morphList.
	index _ self getCurrentSelectionIndex.
	self selectedMorph: ((index = 0 or: [index > morphList size])
			ifFalse: [morphList at: index]).
	self setScrollDeltas.
	scrollBar setValue: 0.0! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'sr 4/27/2000 17:05'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel dragEnabled: dragFlag dropEnabled: dropFlag 
	self model: anObject.
	getListSelector _ getListSel.
	getIndexSelector _ getSelectionSel.
	setIndexSelector _ setSelectionSel.
	getMenuSelector _ getMenuSel.
	keystrokeActionSelector _ keyActionSel.
	dragEnabled _ dragFlag.
	dropEnabled _ dropFlag.
	dragEnabled | dropEnabled ifTrue: [self openToEdits].
	autoDeselect _ true.
	self borderWidth: 1.
	self list: self getList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:59'!
mouseDown: event onItem: aMorph 
	| now delta |
	event yellowButtonPressed ifTrue: [^ self yellowButtonActivity: event shiftPressed].
		eventStatus _ nil.
	lastMouseDownPosition _ event cursorPoint.
	now _ Time millisecondClockValue.
	delta _ ((lastClickTime ifNil: [0])
				- now) abs.
	lastClickTime _ now.
	(aMorph == selectedMorph
		and: [doubleClickSelector notNil and: [delta < DoubleClickTime]])
		ifTrue: [model perform: doubleClickSelector]
		ifFalse: 
			[model okToChange ifFalse: [^ self].
			"No change if model is locked"
			aMorph == selectedMorph
				ifFalse: 
					[self setSelectedMorph: aMorph.
					eventStatus _ #justSelected]]! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:58'!
mouseEnter: event
	super mouseEnter: event.
	event hand newKeyboardFocus: self.
	potentialDropMorph _ nil
! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:57'!
mouseEnterDragging: anEvent onItem: aStringMorph 
	anEvent hand hasSubmorphs ifFalse: ["no d&d"
		^ self].
	(self model
		wantsDroppedMorph: anEvent hand firstSubmorph
		event: anEvent
		atListMorph: self)
		ifTrue: 
			[aStringMorph color: self dragSelectionColor.
			potentialDropMorph _ aStringMorph]! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:57'!
mouseLeaveDragging: anEvent onItem: aStringMorph 
	anEvent hand hasSubmorphs ifFalse: ["no d&d"
		^ self].
	(self model
		wantsDroppedMorph: anEvent hand firstSubmorph
		event: anEvent
		atListMorph: self)
		ifTrue: 
			[aStringMorph color: (self leaveDraggingColorForItemMorph: aStringMorph).
			potentialDropMorph _ nil]! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:57'!
mouseStillDown: evt onItem: item 
	| dist |
	evt redButtonPressed
		ifTrue: 
			[dist _ (evt cursorPoint - lastMouseDownPosition) abs.
			(dist x max: dist y)
				> 5
				ifTrue: 
					[eventStatus _ #dragging.
					self drag: evt itemMorph: item]]! !

!PluggableListMorph methodsFor: 'events' stamp: 'sr 4/23/2000 04:56'!
mouseUp: event onItem: aMorph 
	eventStatus == #dragging | (eventStatus == #justSelected)
		ifTrue: 
			[eventStatus _ nil.
			^ self].
	model okToChange ifFalse: [^ self].
	"No change if model is locked"
	(autoDeselect isNil or: [autoDeselect])
		ifTrue: [aMorph == selectedMorph ifTrue: [self setSelectedMorph: nil]]! !

!PluggableListMorph methodsFor: 'object fileIn' stamp: 'sma 5/12/2000 20:59'!
convertbosfcebbmsopssrsggslssggskafllld0: varDict bosfcebbmsopssrsggslssggskafllldddlep0: smartRefStrm
	"These variables are automatically stored into the new instance ('bounds' 'owner' 'submorphs' 'fullBounds' 'color' 'extension' 'borderWidth' 'borderColor' 'model' 'slotName' 'open' 'pinSpecs' 'scrollBar' 'scroller' 'retractableScrollBar' 'scrollBarOnLeft' 'getMenuSelector' 'getMenuTitleSelector' 'scrollBarHidden' 'list' 'selectedMorph' 'selection' 'getListSelector' 'getIndexSelector' 'setIndexSelector' 'keystrokeActionSelector' 'autoDeselect' 'font' 'lastKeystrokeTime' 'lastKeystrokes' 'lastClickTime' 'doubleClickSelector' ).
	This method is for additional changes. Use statements like (foo _ varDict at: 'foo')."

	"New variables: ('dragEnabled' 'dropEnabled' 'lastMouseDownPosition' 'eventStatus' 'potentialDropMorph' )  If a non-nil value is needed, please assign it."
	dragEnabled _ false.
	dropEnabled _ false.  "other variables should be ok --sma"! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 05:03'!
acceptDroppingMorph: aMorph event: evt 
	"This message is sent when a morph is dropped onto a morph that has     
	agreed to accept the dropped morph by responding 'true' to the     
	wantsDroppedMorph:Event: message. The default implementation just     
	adds the given morph to the receiver."
	"Here we let the model do its work."
	self owner model
		acceptDroppingMorph: aMorph
		event: evt
		atListMorph: self! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/26/2000 04:34'!
drag: evt itemMorph: itemMorph 
	| ddm passengerMorph |
	evt hand hasSubmorphs not
		ifTrue: 
			[itemMorph ~= selectedMorph ifTrue: [self setSelectedMorph: itemMorph].
			passengerMorph _ Morph newBounds: (((scroller transformFrom: self)
							localBoundsToGlobal: selectedMorph bounds)
							intersect: scroller bounds)
						color: color darker.
			passengerMorph addMorph: (itemMorph veryDeepCopy position: passengerMorph position).
			ddm _ TransferMorph
						withPassenger: itemMorph contents
						morph: passengerMorph
						event: evt
						from: self.
			evt hand grabMorph: ddm]! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 05:03'!
dragSelectionColor
	^ Color magenta! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 05:03'!
dropFailColorForItemMorph: itemMorph 
	^ self leaveDraggingColorForItemMorph: itemMorph! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 05:03'!
dropSuccessColor
	^ Color blue! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 05:03'!
leaveDraggingColorForItemMorph: itemMorph 
	^ itemMorph ~~ selectedMorph
		ifTrue: [Color black]
		ifFalse: [Color red]! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/23/2000 08:14'!
showDropSuccess: success forItemWithContents: aSelector 
	scroller submorphsDo: [:itemMorph | itemMorph color: ((success and: [itemMorph contents withBlanksCondensed asSymbol = aSelector])
				ifTrue: [self dropSuccessColor]
				ifFalse: [self dropFailColorForItemMorph: itemMorph])]! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'sr 4/27/2000 16:53'!
wantsDroppedMorph: aMorph event: anEvent 
	^ (super wantsDroppedMorph: aMorph event: anEvent ) and: [self owner model
		wantsDroppedMorph: aMorph
		event: anEvent
		atListMorph: self]! !

!PluggableListMorph methodsFor: 'accessing d&d' stamp: 'sr 4/23/2000 07:25'!
dragEnabled
	"#ifNil: for compatibility with old PluggableListMorphs"
	^ dragEnabled ifNil: [false]! !

!PluggableListMorph methodsFor: 'accessing d&d' stamp: 'sr 4/23/2000 07:24'!
dropEnabled
	"#ifNil: for compatibility with old PluggableListMorphs"
	^ dropEnabled ifNil: [false]! !

!PluggableListMorph methodsFor: 'accessing d&d' stamp: 'sr 4/23/2000 05:04'!
potentialDropMorph
	^potentialDropMorph! !


!PluggableListMorph class methodsFor: 'instance creation' stamp: 'sr 4/23/2000 06:16'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel dragAndDropEnabled: dragNDropFlag
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: #arrowKey:from:		"default"
		dragEnabled: dragNDropFlag
		dropEnabled: dragNDropFlag
! !

!PluggableListMorph class methodsFor: 'instance creation' stamp: 'sr 5/5/2000 17:32'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel dragEnabled: dragFlag dropEnabled: dropFlag 
	"Create a 'pluggable' list view on the given model parameterized by the  
	given message selectors. See ListView>>aboutPluggability comment."
	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: #arrowKey:from:
		dragEnabled: dragFlag
		dropEnabled: dropFlag! !

!PluggableListMorph class methodsFor: 'instance creation' stamp: 'sr 4/23/2000 05:55'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel dragAndDropEnabled: dragNDropFlag
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel
		dragEnabled: dragNDropFlag
		dropEnabled: dragNDropFlag
! !

!PluggableListMorph class methodsFor: 'instance creation' stamp: 'sr 4/23/2000 05:55'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel dragEnabled: dragFlag dropEnabled: dropFlag
	"Create a 'pluggable' list view on the given model parameterized by the given message selectors. See ListView>>aboutPluggability comment."

	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel
		dragEnabled: dragFlag
		dropEnabled: dropFlag
! !


!PluggableMessageCategoryListMorph methodsFor: 'as yet unclassified' stamp: 'sr 4/27/2000 17:06'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel getRawListSelector: getRawSel dragEnabled: dragFlag dropEnabled: dropFlag 
	self model: anObject.
	getListSelector _ getListSel.
	getIndexSelector _ getSelectionSel.
	setIndexSelector _ setSelectionSel.
	getMenuSelector _ getMenuSel.
	keystrokeActionSelector _ keyActionSel.
	dragEnabled _ dragFlag.
	dropEnabled _ dropFlag.
	dragEnabled | dropEnabled ifTrue: [self openToEdits].
	autoDeselect _ true.
	self borderWidth: 1.
	getRawListSelector _ getRawSel.
	self list: self getList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !


!PluggableMessageCategoryListMorph class methodsFor: 'as yet unclassified' stamp: 'sr 4/23/2000 06:04'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel getRawListSelector: getRawSel dragAndDropEnabled: dragNDropFlag
	^ self new on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel getRawListSelector: getRawSel dragEnabled: dragNDropFlag dropEnabled: dragNDropFlag! !

!PluggableMessageCategoryListMorph class methodsFor: 'as yet unclassified' stamp: 'sr 4/25/2000 22:34'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel getRawListSelector: getRawSel dragEnabled: dragFlag dropEnabled: dropFlag 
	^ self new
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		menu: getMenuSel
		keystroke: keyActionSel
		getRawListSelector: getRawSel
		dragEnabled: dragFlag
		dropEnabled: dropFlag! !


!PluggableTextMorph methodsFor: 'accessing' stamp: 'sr 4/25/2000 07:21'!
getTextSelector
	^getTextSelector! !


!PolygonMorphDashed methodsFor: 'initialization' stamp: 'sr 4/25/2000 21:37'!
vertices: verts color: c firstBorderWidth: bw1 secondBorderWidth: bw2 firstBorderColor: bc1 secondBorderColor: bc2 firstBorderStepWidth: bs1 secondBorderStepWidth: bs2 
	super
		vertices: verts
		color: c
		borderWidth: bw1
		borderColor: bc1.
	secondBorderWidth _ bw2.
	secondBorderColor _ bc2.
	firstBorderStepWidth _ bs1.
	secondBorderStepWidth _ bs2! !

!PolygonMorphDashed methodsFor: 'drawing' stamp: 'sr 4/25/2000 21:28'!
drawBorderOn: aCanvas 
	"Display my border on the canvas."
	| lineColor bevel topLeftColor bottomRightColor bigClipRect brush p1i p2i |
	(borderColor == nil
		or: [borderColor isColor and: [borderColor isTransparent]])
		ifTrue: [^ self].
	lineColor _ borderColor.
	bevel _ false.
	"Border colors for bevelled effects depend on CW ordering of vertices"
	borderColor == #raised
		ifTrue: 
			[topLeftColor _ color lighter.
			bottomRightColor _ color darker.
			bevel _ true].
	borderColor == #inset
		ifTrue: 
			[topLeftColor _ owner colorForInsets darker.
			bottomRightColor _ owner colorForInsets lighter.
			bevel _ true].
	bigClipRect _ aCanvas clipRect expandBy: self borderWidth + 1 // 2.
	brush _ nil.
	self
		lineSegmentsDo: 
			[:p1 :p2 | 
			p1i _ p1 asIntegerPoint.
			p2i _ p2 asIntegerPoint.
			(closed or: ["bigClipRect intersects: (p1i rect: p2i) optimized:"
				((p1i min: p2i)
					max: bigClipRect origin)
					<= ((p1i max: p2i)
							min: bigClipRect corner)])
				ifTrue: 
					[bevel
						ifTrue: [(p1i quadrantOf: p2i)
								> 2
								ifTrue: [lineColor _ topLeftColor]
								ifFalse: [lineColor _ bottomRightColor]].
					(borderWidth > 3 and: [borderColor isColor])
						ifTrue: 
							[brush == nil ifTrue: [brush _ (ColorForm dotOfSize: borderWidth)
											colors: (Array with: Color transparent with: borderColor)].
							aCanvas
								line: p1i
								to: p2i
								brushForm: brush]
						ifFalse: [aCanvas
								line: p1i
								to: p2i
								width: borderWidth
								color: borderColor
								stepWidth: firstBorderStepWidth
								secondWidth: secondBorderWidth
								secondColor: secondBorderColor
								secondStepWidth: secondBorderStepWidth]]]! !


!PolygonMorphDashed class methodsFor: 'instance creation' stamp: 'sr 4/25/2000 21:37'!
vertices: verts color: c firstBorderWidth: bw1 secondBorderWidth: bw2 firstBorderColor: bc1 secondBorderColor: bc2 firstBorderStepWidth: bs1 secondBorderStepWidth: bs2 
	^ self basicNew
		vertices: verts
		color: c
		firstBorderWidth: bw1
		secondBorderWidth: bw2
		firstBorderColor: bc1
		secondBorderColor: bc2
		firstBorderStepWidth: bs1
		secondBorderStepWidth: bs2! !

!PolygonMorphDashed class methodsFor: 'as yet unclassified' stamp: 'sr 4/27/2000 18:54'!
animationExample
	"PolygonMorphDashed animationExample"
	| m numOfAnimationSteps start stop stepVec s delay delayAtAll point animation |
	m _ self
				vertices: {Display boundingBox origin. Display boundingBox corner}
				color: Color transparent
				firstBorderWidth: 2
				secondBorderWidth: 2
				firstBorderColor: Color black
				secondBorderColor: Color white
				firstBorderStepWidth: 10
				secondBorderStepWidth: 10.
	m lock.
	m openInWorld.
	World refreshWorld.
	(Delay forSeconds: 1) wait.
	numOfAnimationSteps _ 25.
	delayAtAll _ 1.
	start _ m vertices at: 1.
	stop _ m vertices at: 2.
	start = stop ifTrue: [^ self].
	stepVec _ stop - start / (numOfAnimationSteps + 1).
	s _ Array new: numOfAnimationSteps.
	1 to: numOfAnimationSteps do: 
		[:step | 
		point _ start + (step * stepVec).
		"avoid problems"
		s at: step put: (point = stop
				ifTrue: 
					[
					stop - (1 @ 1)]
				ifFalse: [point])].
	delay _ Delay forSeconds: delayAtAll / numOfAnimationSteps.
	animation _ 
			[1 to: s size do: 
				[:j | 
				"Move to the next point"
				m vertices at: 1 put: (s at: j).
				"update"
				m computeBounds.
				"not necessary here since forked"
				"	World refreshWorld."
				"for fast machines"
				delay wait].
			m delete].
	animation fork! !


!Preferences class methodsFor: 'help' stamp: 'sr 5/5/2000 03:30'!
helpMsgsAddition4sr
	^ #(
(browseWithDragNDrop
	'If true, drag&drop browsing is enabled, new Browser are opened with drag&drop functionality (only in Morphic).')
(dragNDropWithAnimation
	'If true, drag&drop is animated.')
)

! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 5/5/2000 03:26'!
browseWithDragNDrop
	^ self valueOfFlag: #browseWithDragNDrop! !

!Preferences class methodsFor: 'standard preferences' stamp: 'programmatic 4/27/2000 04:06'!
dragNDropWithAnimation
	^ self valueOfFlag: #dragNDropWithAnimation! !

!Preferences class methodsFor: 'initial values' stamp: 'sr 5/5/2000 03:21'!
initialValuesAddition4sr
	^ #((browseWithDragNDrop true (browsing ) ) (dragNDropWithAnimation true (browsing ) ) )! !


!TransferMorph methodsFor: 'private' stamp: 'sr 5/4/2000 23:26'!
privateFullMoveBy: delta 
	super privateFullMoveBy: delta.
	self updateMyPolygon! !

!TransferMorph methodsFor: 'submorphs-add/remove' stamp: 'sr 4/24/2000 15:30'!
delete
	"See also >>justDroppedInto:event:."
	accepted ifFalse: [self dropNotifyRecipient ifNotNil: [self dropNotifyRecipient dropRejectedMorph: self]].
		myPolygon
		ifNotNil: 
			[myPolygon delete.
			myPolygon _ nil].
super delete! !

!TransferMorph methodsFor: 'submorphs-add/remove' stamp: 'sr 4/24/2000 21:09'!
grabPositionAtPassengerMorph: aMorph 
	"could be overridden by subclasses"
	^ aMorph bottomLeft! !

!TransferMorph methodsFor: 'submorphs-add/remove' stamp: 'sr 4/27/2000 15:15'!
passengerMorph
	^ self hasSubmorphs ifNotNil: [self firstSubmorph]! !

!TransferMorph methodsFor: 'submorphs-add/remove' stamp: 'sr 4/27/2000 14:23'!
passengerMorph: aMorph 
	| passengerMorph |
	aMorph ifNil: [passengerMorph _ PolygonMorph
					vertices: (Array
							with: 0 @ 10
							with: 10 @ 10
							with: 5 @ 0)
					color: Color red
					borderWidth: 1
					borderColor: Color black]
		ifNotNil: 
			[passengerMorph _ aMorph.
			passengerMorph color: (passengerMorph color alpha: 0.7)].
		startPositionForLine _ passengerMorph center.
	self position: (self grabPositionAtPassengerMorph: passengerMorph).
	startPosition _ self position.
	self addMorph: passengerMorph! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 5/4/2000 22:53'!
dragActionActive: anObject
	dragActionActive _ anObject! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/27/2000 20:38'!
hasCopySemantic
	^ semantic == #copy! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/16/2000 18:52'!
passenger
	^passenger! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/16/2000 18:53'!
passenger: anObject
	passenger _ anObject! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/26/2000 04:40'!
semantic: anObject
	semantic _ anObject! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/16/2000 11:55'!
source
	^source! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 4/16/2000 18:53'!
source: anObject
	source _ anObject! !

!TransferMorph methodsFor: 'accessing' stamp: 'sr 5/5/2000 03:44'!
success: aBool 
	successFlag _ aBool
! !

!TransferMorph methodsFor: 'initialization' stamp: 'sr 5/4/2000 22:48'!
initialize
	super initialize.
	self extent: 0 @ 0.
	semantic _ #move.
	accepted _ false! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 5/5/2000 03:09'!
aboutToBeGrabbedBy: aHand 
	| polygonVertices |
	self position: aHand position.
	semantic == #copy ifTrue: [self addMorph: ((ImageMorph new image: PlusForCursor)
				position: self position)].
	Preferences dragNDropWithAnimation & (semantic == #move)
		ifTrue: 
			[polygonVertices _ Array with: startPositionForLine with: startPositionForLine.
			myPolygon _ PolygonMorphDashed
						vertices: polygonVertices
						color: Color transparent
						firstBorderWidth: 2
						secondBorderWidth: 2
						firstBorderColor: Color black
						secondBorderColor: Color white
						firstBorderStepWidth: 10
						secondBorderStepWidth: 10.
			World addMorphFront: myPolygon]! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 5/5/2000 02:00'!
animationForMoveSuccess: success 
	| m numOfAnimationSteps delayAtAll start stop stepVec s point delay |
	(m _ myPolygon) ifNil: [^ self].
	self lock.
	m lock.
	self comeToFront.
	m comeToFront.
	self submorphs do: [:sm | sm comeToFront].
	numOfAnimationSteps _ 25.
	delayAtAll _ 1.
	success
		ifTrue: 
			[start _ startPositionForLine.
			stop _ self passengerMorph center]
		ifFalse: 
			[start _ self position.
			stop _ startPosition].
	start = stop ifTrue: [^ self].
	stepVec _ stop - start / (numOfAnimationSteps + 1).
	s _ Array new: numOfAnimationSteps.
	1 to: numOfAnimationSteps do: 
		[:step | 
		point _ start + (step * stepVec).
		"avoid problems"
		s at: step put: point asIntegerPoint].
	delay _ Delay forSeconds: delayAtAll / numOfAnimationSteps.
	1 to: s size do: 
		[:j | 
		"Move to the next point"
		success
			ifTrue: 
				[m vertices at: 1 put: (s at: j).
				"update"
				m computeBounds]
			ifFalse: [self position: (s at: j)].
		"not necessary here since forking seems to work well"
		"self refreshWorld."
		"for fast machines"
		delay wait]! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 4/16/2000 18:52'!
dropNotifyRecipient
	^dropNotifyRecipient! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 5/5/2000 16:45'!
justDroppedInto: targetMorph event: anEvent 
	"If only world wants this TransferMorph, treat it as unaccepted (see     
	also>>delete). Var dragActionActive is necessary, because under some    
	circumstances this method is called more than once."
	dragActionActive
		ifNotNil: [dragActionActive ifTrue: ["don't finish if dragAction not finished"
				^ self]].
	"drag&drop operation finished"
	super justDroppedInto: targetMorph event: anEvent.
	accepted _ targetMorph ~= self world & (successFlag ifNil: [false]).
	accepted ifTrue: [self dropNotifyRecipient ifNotNil: [self dropNotifyRecipient dropAcceptedMorph: self from: targetMorph]].
	Preferences dragNDropWithAnimation & (semantic == #move)
		ifTrue: [
			[self animationForMoveSuccess: accepted.
			self delete]
				forkAt: Processor userBackgroundPriority]
		ifFalse: [self delete]! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 4/16/2000 18:53'!
result: result 
	^ self result: result from: nil! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'sr 4/16/2000 15:08'!
result: aResult from: aResultGenerator 
	"Send aResult of the drop operation computed by aResultGenerator to a   
	resultRecipient, if it exists."
	self resultRecipient ifNotNil: [self resultRecipient dropResult: aResult from: aResultGenerator]! !

!TransferMorph methodsFor: 'drawing' stamp: 'sr 4/27/2000 18:41'!
updateMyPolygon
	myPolygon ifNil: [^ self].
	myPolygon vertices at: 2 put: self passengerMorph center.
	myPolygon computeBounds! !


!TransferMorph class methodsFor: 'initialize' stamp: 'sr 4/26/2000 04:24'!
initPlusForCursor
	PlusForCursor _ (Form
	extent: 16@16
	depth: 8
	fromArray: #( 0 0 65535 0 0 0 16768220 4278190080 0 0 16768220 4278190080 0 255 4294958300 4294967040 0 65500 3705461980 3705462015 0 65500 3705461980 3705462015 0 255 4294958300 4294967295 0 0 16768220 4278190080 0 0 16768220 4278190080 0 0 65535 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!TransferMorph class methodsFor: 'initialize' stamp: 'sr 4/26/2000 04:25'!
initialize
	"TransferMorph initialize."
	self initPlusForCursor! !

!TransferMorph class methodsFor: 'instance creation' stamp: 'sr 4/13/2000 21:52'!
withPassenger: anObject 
	^ self withPassenger: anObject from: nil! !

!TransferMorph class methodsFor: 'instance creation' stamp: 'sr 4/23/2000 04:52'!
withPassenger: anObject from: source 
	^ self withPassenger: anObject morph: nil from: source! !

!TransferMorph class methodsFor: 'instance creation' stamp: 'sr 4/26/2000 04:47'!
withPassenger: passenger morph: aMorph event: evt from: source 
	^ self new passengerMorph: aMorph;
	 passenger: passenger;
	 semantic: (evt shiftPressed
			ifTrue: [#copy]
			ifFalse: [#move]);
	 source: source;
	 yourself! !

!TransferMorph class methodsFor: 'instance creation' stamp: 'sr 4/23/2000 03:56'!
withPassenger: passenger morph: aMorph from: source 
	^ self new passengerMorph: aMorph;
	 passenger: passenger;
	 source: source;
	 yourself! !


!Utilities class methodsFor: 'sr' stamp: 'sr 5/6/2000 02:10'!
dragNDropDomestos
	"for cleaning dragNDrop artifacts"
	TransferMorph allInstances do: [:e | e abandon]! !

!Utilities class methodsFor: 'sr' stamp: 'sr 5/6/2000 07:52'!
dragNDropDomestosStrong
	"for breaking bad dependencies"
	| winsWithoutOwner browserWins modelsWithDependents obsoleteModels morphs |
	self dragNDropDomestos.
	browserWins _ SystemWindow allInstances select: [:sw | sw model isKindOf: Browser].
	winsWithoutOwner _ browserWins select: [:bw | bw owner isNil].
	winsWithoutOwner do: [:win | win allMorphs do: 
			[:sm | 
			(sm respondsTo: #model)
				ifTrue: [sm model: nil].
			sm abandon]].
	"modelsWithoutDependents _ Browser allSubInstances select: [:bi | bi        
	   dependents isEmpty].           
	modelsWithoutDependents do: [:model | (Smalltalk pointersTo: model)        
	   do:            
	[:ref |            
	ref isMorph ifTrue: [ref abandon].           
	((ref respondsTo: #model)           
	and: [ref model == model])           
	ifTrue: [ref model: nil]]].          
	"
	modelsWithDependents _ Browser allSubInstances select: [:bi | bi dependents isEmpty not].
	obsoleteModels _ modelsWithDependents
				select: [:model | (model dependents
						detect: [:dep | (dep isKindOf: SystemWindow)
								and: [dep owner isNil]]
						ifNone: []) notNil or: [(model dependents detect: [:dep2 | dep2 isKindOf: SystemWindow]
							ifNone: []) isNil]].
	obsoleteModels do: 
		[:model | 
		morphs _ model dependents
					select: [:dep | dep isMorph and: [dep pasteUpMorph isNil]].
		morphs do: 
			[:m | 
			m abandon.
			((m respondsTo: #model)
				and: [m model == model])
				ifTrue: [m model: nil]]].
	Smalltalk garbageCollect! !

TransferMorph initialize!
ScrollPane subclass: #PluggableListMorph
	instanceVariableNames: 'list selectedMorph selection getListSelector getIndexSelector setIndexSelector keystrokeActionSelector autoDeselect font lastKeystrokeTime lastKeystrokes lastClickTime doubleClickSelector dragEnabled dropEnabled lastMouseDownPosition eventStatus potentialDropMorph '
	classVariableNames: 'DoubleClickTime '
	poolDictionaries: ''
	category: 'Morphic-Windows'!
"Postscript:
"

TransferMorph initialize.
Preferences absorbAdditions.
!!!

